#!/usr/bin/perl
#
# cons-test [-x cons] [test_script ...]
#
#	Run the cons regression test suite.
#

require "getopts.pl";

($My_Name = $0) =~ s(.*/)();	# basename
$Usage="Usage:  $My_Name [-x cons] [test_script ...]";

&Getopts('x:') || die "$Usage\n";

if (defined($opt_x)) {
	$Cons = $ENV{'PROG'} = $opt_x;
} else {
	$Cons = 'cons';
}

if (!@ARGV) {
	opendir(DIR, '.') || die "$My_Name: cannot open current directory: $!\n";
	@ARGV = grep(/t[0-9]+a.sh/, readdir(DIR));
	closedir(DIR);
}

foreach $test (@ARGV) {
	my($cmd) = "sh $test";
	print "$My_Name:  $cmd\n";
	if (system($cmd)) {
		push(@fail, $test);
	} else {
		$pass++;
	}
}

print "\n";
if (@fail == 0) {
	print "$My_Name:  '$Cons' passed all $pass tests.\n";
} else {
	printf "$My_Name:  '$Cons' passed $pass tests, failed %d:\n", @fail;
	print "\t\t", join("\n\t\t", @fail), "\n";
}

exit @fail;
